﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Input;

namespace Petzold.Controls
{
    public partial class TouchDatePicker : UserControl
    {
        DatePresenter datePresenter = new DatePresenter();

        public static readonly DependencyProperty DateTimeProperty =
            DependencyProperty.Register("DateTime",
                typeof(DateTime),
                typeof(TouchDatePicker),
                new PropertyMetadata(DateTime.Now));

        public TouchDatePicker()
        {
            InitializeComponent();

            Binding binding = new Binding();
            binding.Source = datePresenter;
            binding.Path = new PropertyPath("DateTime", null);
            binding.Mode = BindingMode.TwoWay;
            SetBinding(DateTimeProperty, binding);

            DataContext = datePresenter;
        }

        public DateTime DateTime
        {
            set { SetValue(DateTimeProperty, value); }
            get { return (DateTime)GetValue(DateTimeProperty); }
        }

        void OnWindowedItemsControlIsActiveChanged(object sender, DependencyPropertyChangedEventArgs args)
        {
            if ((bool)args.NewValue)
            {
                monthControl.IsActive = sender == monthControl;
                dayControl.IsActive = sender == dayControl;
                yearControl.IsActive = sender == yearControl;
            }
        }
    }
}
